%define major 3
%define libname %mklibname gd %{major}
%define develname %mklibname gd -d
%define staticdevelname %mklibname gd -d -s

Summary:	A library used to create PNG, JPEG, or WBMP images
Name:		libgd
Version:	2.3.1
%define subrel 1
Release:	%mkrel 1
License:	BSD-like
Group:		System/Libraries
URL:		http://www.libgd.org/
Source0:	https://github.com/libgd/libgd/releases/download/gd-%{version}/%{name}-%{version}.tar.xz
Source1:	https://raw.githubusercontent.com/libgd/libgd/gd-%{version}/config/getlib.sh
Patch0:		CVE-2021-38115.patch
Patch1:		CVE-2021-40145.patch
BuildRequires:	pkgconfig(fontconfig)
BuildRequires:	pkgconfig(freetype2) >= 9.8.3
BuildRequires:	pkgconfig(libpng)
BuildRequires:	pkgconfig(libtiff-4)
BuildRequires:	pkgconfig(libwebp)
BuildRequires:	pkgconfig(xpm)
BuildRequires:	pkgconfig(libjpeg)
BuildRequires:	pkgconfig(zlib)
BuildRequires:	gettext-devel
BuildRequires:	raqm-devel
# for fontconfig/basic test
BuildRequires:	fonts-ttf-liberation
BuildRequires:	mercurial

%description
gd is a graphics library. It allows your code to quickly draw images complete
with lines, arcs, text, multiple colors, cut and paste from other images, and
flood fills, and write out the result as a PNG or JPEG file. This is
particularly useful in World Wide Webapplications, where PNG and JPEG are two
of the formats accepted for in-line images by most browsers.

gd is not a paint program. If you are looking for a paint program, you are
looking in the wrong place. If you are not a programmer, you are looking in the
wrong place. 

gd does not provide for every possible desirable graphics operation. It is not
necessary or desirable for gd to become a kitchen-sink graphics package, but
version 1.7.3 incorporates most of the commonly requested features for an 8-bit
2D package.

%package -n	%{libname}
Summary:	A library used to create PNG, JPEG, or WBMP images
Group:		System/Libraries
Provides:	gd = %{version}-%{release}
Obsoletes:	gd

%description -n	%{libname}
gd is a graphics library. It allows your code to quickly draw images complete
with lines, arcs, text, multiple colors, cut and paste from other images, and
flood fills, and write out the result as a PNG or JPEG file. This is
particularly useful in World Wide Webapplications, where PNG and JPEG are two
of the formats accepted for in-line images by most browsers.

gd is not a paint program. If you are looking for a paint program, you are
looking in the wrong place. If you are not a programmer, you are looking in the
wrong place. 

gd does not provide for every possible desirable graphics operation. It is not
necessary or desirable for gd to become a kitchen-sink graphics package, but
version 1.7.3 incorporates most of the commonly requested features for an 8-bit
2D package.

This package contains the library needed to run programs dynamically linked
with libgd.

%package -n	%{develname}
Summary:	The development libraries and header files for gd
Group:		Development/C
Requires:	%{libname} = %{version}
Requires:	raqm-devel
Provides:	gd-devel = %{version}-%{release}
Obsoletes:	gd-devel
Provides:	%{name}-devel = %{version}-%{release}

%description -n	%{develname}
gd is a graphics library. It allows your code to quickly draw images complete
with lines, arcs, text, multiple colors, cut and paste from other images, and
flood fills, and write out the result as a PNG or JPEG file. This is
particularly useful in World Wide Webapplications, where PNG and JPEG are two
of the formats accepted for in-line images by most browsers.

gd is not a paint program. If you are looking for a paint program, you are
looking in the wrong place. If you are not a programmer, you are looking in the
wrong place. 

gd does not provide for every possible desirable graphics operation. It is not
necessary or desirable for gd to become a kitchen-sink graphics package, but
version 1.7.3 incorporates most of the commonly requested features for an 8-bit
2D package.

These are the development libraries and header files for gd, the .png and .jpeg
graphics library. If you're installing the gd graphics library, you'll probably
want to install gd-devel.

%package -n	%{staticdevelname}
Summary:	Static GD library
Group:		Development/C
Requires:	%{develname} = %{version}
Provides:	libgd-static-devel = %{version}-%{release}
Provides:	gd-static-devel = %{version}-%{release}

%description -n	%{staticdevelname}
gd is a graphics library. It allows your code to quickly draw images complete
with lines, arcs, text, multiple colors, cut and paste from other images, and
flood fills, and write out the result as a PNG or JPEG file. This is
particularly useful in World Wide Webapplications, where PNG and JPEG are two
of the formats accepted for in-line images by most browsers.

gd is not a paint program. If you are looking for a paint program, you are
looking in the wrong place. If you are not a programmer, you are looking in the
wrong place. 

gd does not provide for every possible desirable graphics operation. It is not
necessary or desirable for gd to become a kitchen-sink graphics package, but
version 1.7.3 incorporates most of the commonly requested features for an 8-bit
2D package.

This package contains static gd library.

%package -n	gd-utils
Summary:	The Utils files for gd
Group:		System/Libraries
Requires:	%{libname} = %{version}

%description -n	gd-utils
gd is a graphics library. It allows your code to quickly draw images complete
with lines, arcs, text, multiple colors, cut and paste from other images, and
flood fills, and write out the result as a PNG or JPEG file. This is
particularly useful in World Wide Webapplications, where PNG and JPEG are two
of the formats accepted for in-line images by most browsers.

gd is not a paint program. If you are looking for a paint program, you are
looking in the wrong place. If you are not a programmer, you are looking in the
wrong place. 

gd does not provide for every possible desirable graphics operation. It is not
necessary or desirable for gd to become a kitchen-sink graphics package, but
version 1.7.3 incorporates most of the commonly requested features for an 8-bit
2D package.

This package contains various utilities utilizing the gd library.

%prep
%setup -q -n libgd-%{version}
%autopatch -p1
install -m 0755 %{SOURCE1} config/

%build
%ifarch %{ix86}
# see https://github.com/libgd/libgd/issues/242
CFLAGS="-msse -mfpmath=sse"
%endif

%ifarch aarch64
# workaround for https://bugzilla.redhat.com/show_bug.cgi?id=1359680
CFLAGS="$CFLAGS -ffp-contract=off"
%endif

# Provide a correct default font search path
CFLAGS="$CFLAGS -DDEFAULT_FONTPATH='\"\
/usr/share/fonts/TTF:\
/usr/share/fonts/TTF/dejavu:\
/usr/share/fonts/default/Type1:\
/usr/share/fonts/fonts/Type1:\
/usr/share/fonts/TTF/liberation\"'"

export CFLAGS="%{optflags} $CFLAGS"

autoreconf -fi
%configure --without-libiconv-prefix
%make_build


%check
%ifarch %{ix86}
# See https://github.com/libgd/libgd/issues/359
XFAIL_TESTS="gdimagegrayscale/basic $XFAIL_TESTS"
%endif
# minor diff in size
XFAIL_TESTS="gdimagestringft/gdimagestringft_bbox $XFAIL_TESTS"

export XFAIL_TESTS

: Upstream test suite
make check

%install
%make_install

%multiarch_includes %{buildroot}%{_includedir}/gd.h

install -m 0644 src/gdhelpers.h %{buildroot}%{_includedir}/

rm -f %{buildroot}%{_libdir}/*.la

%files -n %{libname}
%doc docs/README.TXT src/COPYING
%{_libdir}/*.so.%{major}
%{_libdir}/*.so.%{major}.*

%files -n %{develname}
%{_libdir}/*.so
%{_libdir}/pkgconfig/gdlib.pc
%{_includedir}/*.h
%multiarch %{multiarch_includedir}/*.h

%files -n %{staticdevelname}
%{_libdir}/lib*.a

%files -n gd-utils
%{_bindir}/annotate
%{_bindir}/bdftogd
%{_bindir}/gd2copypal
%{_bindir}/gd2topng
%{_bindir}/gdparttopng
%{_bindir}/gdtopng
%{_bindir}/pngtogd
%{_bindir}/pngtogd2
%{_bindir}/webpng
%{_bindir}/gd2togif
%{_bindir}/gdcmpgif
%{_bindir}/giftogd2


%changelog
* Thu Sep 09 2021 ns80 <ns80> 2.3.1-1.1.mga8
+ Revision: 1744580
- add upstream patches for CVE-2021-38115 and CVE-2021-40145 (mga#29448)
- new version 2.3.1 (mga#29019)

* Wed Apr 01 2020 luigiwalser <luigiwalser> 2.3.0-1.mga8
+ Revision: 1562838
- 2.3.0
- remove patches (fixed upstream)
- add Source1 from upstream via fedora, accidentally missing
- build with libraqm
- remove gdlib-config

* Fri Mar 06 2020 ns80 <ns80> 2.2.5-8.mga8
+ Revision: 1554336
- add upstream patch for CVE-2019-11038 (mga#26306)

* Fri Feb 21 2020 ns80 <ns80> 2.2.5-7.mga8
+ Revision: 1549203
- add upstream patch for CVE-2018-14553 (mga#26220)

* Fri Feb 14 2020 umeabot <umeabot> 2.2.5-6.mga8
+ Revision: 1522885
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Mon Feb 11 2019 luigiwalser <luigiwalser> 2.2.5-5.mga7
+ Revision: 1365174
- fix overflow checks related to php#77269 (CVE-2016-10166), from upstream
- add upstream patch to fix CVE-2019-6978
+ mokraemer <mokraemer>
- Fix php#77270 (CVE-2019-6977)

* Fri Aug 31 2018 ns80 <ns80> 2.2.5-4.mga7
+ Revision: 1255913
- add patches for CVE-2018-5711 and CVE-2018-1000222 (mga#23496)

* Mon Jun 11 2018 wally <wally> 2.2.5-3.mga7
+ Revision: 1236331
- add fixes for failing tests

* Fri Jan 05 2018 mokraemer <mokraemer> 2.2.5-2.mga7
+ Revision: 1190468
- fix Potential infinite loop in gdImageCreateFromGifCtx (php#75571, mga#22321)

* Fri Sep 22 2017 ns80 <ns80> 2.2.5-1.mga7
+ Revision: 1157368
- add fontconfig/basic to the list of failing tests
+ luigiwalser <luigiwalser>
- 2.2.5
- remove upstream patches

* Sat Jul 29 2017 luigiwalser <luigiwalser> 2.2.4-5.mga7
+ Revision: 1132515
- try to fix CFLAGS
- add patch from php to fix CVE-2017-7890

* Wed Jun 28 2017 pterjan <pterjan> 2.2.4-3.mga6
+ Revision: 1108617
- Add a call to autoreconf to fix build with new automake

* Mon Jan 30 2017 akien <akien> 2.2.4-2.mga6
+ Revision: 1084265
- Rebuild for BS issue
+ ns80 <ns80>
- new version 2.2.4 for CVE-2016-6912 and CVE-2016-9317 (mga#20171)

* Wed Nov 16 2016 daviddavid <daviddavid> 2.2.3-5.mga6
+ Revision: 1067555
- add patch based on ubuntu to fix also CVE-2016-6911 (mga#19594)

* Sun Oct 16 2016 daviddavid <daviddavid> 2.2.3-4.mga6
+ Revision: 1061005
- add upstream patch to fix CVE-2016-8670 (mga#19594)
- disable only tests that fails

* Wed Oct 05 2016 ns80 <ns80> 2.2.3-3.mga6
+ Revision: 1058938
- add a patch for CVE-2016-7568 (mga#19481)

* Fri Jul 22 2016 daviddavid <daviddavid> 2.2.3-2.mga6
+ Revision: 1043210
- add "-msse -mfpmath=sse" option to CFLAGS thus fixing really testsuite on x86-32 arch
  * see https://github.com/libgd/libgd/issues/242
- add patch from fedora to fix also testsuite on ARM

* Fri Jul 22 2016 luigiwalser <luigiwalser> 2.2.3-1.mga6
+ Revision: 1043173
- 2.2.3 (fixes CVE-2016-6207)

* Wed Jul 20 2016 luigiwalser <luigiwalser> 2.2.2-7.mga6
+ Revision: 1042930
- add upstream patch to fix upstream issue 248
- add binary test case for issue 248 as Source4

* Thu Jul 14 2016 luigiwalser <luigiwalser> 2.2.2-6.mga6
+ Revision: 1041970
- add upstream patch to fix CVE-2016-6214
- add binary test case for CVE-2016-6214 as Source3

* Tue Jul 12 2016 luigiwalser <luigiwalser> 2.2.2-5.mga6
+ Revision: 1041265
- add upstream patch to fix CVE-2016-6132
- add binary test case for CVE-2016-6132 as Source2

* Fri Jul 08 2016 daviddavid <daviddavid> 2.2.2-4.mga6
+ Revision: 1039836
- really fix bogus link on @LIBICONV@ adding BR gettext-devel

* Fri Jul 08 2016 daviddavid <daviddavid> 2.2.2-3.mga6
+ Revision: 1039821
- add --without-libiconv-prefix configure option to fix a bogus
  link on @LIBICONV@ in libgd.pc file

* Thu Jun 30 2016 luigiwalser <luigiwalser> 2.2.2-2.mga6
+ Revision: 1038203
- add upstream patch to fix CVE-2016-5766
- add binary test case for CVE-2016-5766 as Source1
- add upstream patch to fix CVE-2016-6128

* Sat Jun 25 2016 luigiwalser <luigiwalser> 2.2.2-1.mga6
+ Revision: 1037472
- 2.2.2

* Mon May 30 2016 luigiwalser <luigiwalser> 2.2.1-3.mga6
+ Revision: 1019448
- BR libwebp, not vpx, for webp support

* Mon May 30 2016 luigiwalser <luigiwalser> 2.2.1-2.mga6
+ Revision: 1019410
- re-enable webp support (BR libvpx)

* Fri May 27 2016 luigiwalser <luigiwalser> 2.2.1-1.mga6
+ Revision: 1018943
- 2.2.1
- add upstream patch to fix CVE-2015-8877

* Fri May 20 2016 luigiwalser <luigiwalser> 2.1.1-6.mga6
+ Revision: 1017189
- add upstream patch to fix CVE-2015-8874

* Thu Apr 21 2016 luigiwalser <luigiwalser> 2.1.1-5.mga6
+ Revision: 1004179
- add upstream patch to fix CVE-2016-3074

* Tue Dec 22 2015 blino <blino> 2.1.1-4.mga6
+ Revision: 913301
- remove old workaround for doc file permission

* Mon Nov 16 2015 oden <oden> 2.1.1-3.mga6
+ Revision: 903532
- rebuild for new libvpx

* Sat Jun 27 2015 cjw <cjw> 2.1.1-2.mga6
+ Revision: 846267
- patch1: fix build with libvpx 1.4+
- rebuild for new libvpx

* Mon Feb 02 2015 oden <oden> 2.1.1-1.mga5
+ Revision: 813085
- 2.1.1

* Fri Jan 23 2015 luigiwalser <luigiwalser> 2.1.0-8.mga5
+ Revision: 812017
- add upstream changes to fix possible buffer read overflow (php#68601)

* Wed Oct 15 2014 umeabot <umeabot> 2.1.0-7.mga5
+ Revision: 742130
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 2.1.0-6.mga5
+ Revision: 681475
- Mageia 5 Mass Rebuild

* Thu Aug 21 2014 luigiwalser <luigiwalser> 2.1.0-5.mga5
+ Revision: 666100
- use libgd upstream CVE-2014-2497 patch

* Thu Jun 12 2014 luigiwalser <luigiwalser> 2.1.0-4.mga5
+ Revision: 635830
- add patch from PHP bug 66901 to fix CVE-2014-2497 (thx to opensuse for the ref)

* Sat Oct 19 2013 umeabot <umeabot> 2.1.0-3.mga4
+ Revision: 530325
- Mageia 4 Mass Rebuild

* Mon Jul 22 2013 oden <oden> 2.1.0-2.mga4
+ Revision: 457139
- sync with php-5.5.1

* Thu Jul 11 2013 oden <oden> 2.1.0-1.mga4
+ Revision: 452893
- 2.1.0

* Mon Jun 24 2013 oden <oden> 2.1.0-0.0.rc2.2.mga4
+ Revision: 446221
- P0: upstream fix for failing tests on 32bit arch (debian)
- 2.1.0-rc2
+ fwang <fwang>
- add libtiff br

* Sun Jun 02 2013 fwang <fwang> 2.1.0-0.0.rc1.2.mga4
+ Revision: 434643
- rebuild for new libpng

* Sun May 26 2013 oden <oden> 2.1.0-0.0.rc1.1.mga4
+ Revision: 428141
- imported package libgd

